Index: gcc/testsuite/gfortran.dg/array_temporaries_4.f90
===================================================================
--- gcc/testsuite/gfortran.dg/array_temporaries_4.f90	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gfortran.dg/array_temporaries_4.f90	(.../branches/gcc-7-branch)
@@ -0,0 +1,59 @@
+! { dg-do compile }
+! { dg-options "-Warray-temporaries" }
+! Tests the fix for PR80164, in which the compiler segfaulted on this
+! when using -Warray-temporaries
+!
+!******************************************************************************
+module global
+  type :: a
+    integer :: b
+    character(8):: c
+  end type a
+  interface assignment(=)
+    module procedure a_to_a, c_to_a, a_to_c
+  end interface
+  interface operator(.ne.)
+    module procedure a_ne_a
+  end interface
+
+  type(a) :: x(4), y(4)
+  logical :: l1(4), t = .true., f= .false.
+contains
+!******************************************************************************
+  elemental subroutine a_to_a (m, n)
+    type(a), intent(in) :: n
+    type(a), intent(out) :: m
+    m%b = len ( trim(n%c))
+    m%c = n%c
+  end subroutine a_to_a
+  elemental subroutine c_to_a (m, n)
+    character(8), intent(in) :: n
+    type(a), intent(out) :: m
+    m%b = m%b + 1
+    m%c = n
+  end subroutine c_to_a
+  elemental subroutine a_to_c (m, n)
+    type(a), intent(in) :: n
+    character(8), intent(out) :: m
+    m = n%c
+  end subroutine a_to_c
+!******************************************************************************
+  elemental logical function a_ne_a (m, n)
+    type(a), intent(in) :: n
+    type(a), intent(in) :: m
+    a_ne_a = (m%b .ne. n%b) .or. (m%c .ne. n%c)
+  end function a_ne_a
+!******************************************************************************
+  elemental function foo (m)
+    type(a) :: foo
+    type(a), intent(in) :: m
+    foo%b = 0
+    foo%c = m%c
+  end function foo  
+end module global
+!******************************************************************************
+program test
+  use global
+  x = (/a (0, "one"),a (0, "two"),a (0, "three"),a (0, "four")/) ! { dg-warning "Creating array temporary" }
+  y = x
+end program test 
Index: gcc/testsuite/gfortran.dg/zero_sized_7.f90
===================================================================
--- gcc/testsuite/gfortran.dg/zero_sized_7.f90	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gfortran.dg/zero_sized_7.f90	(.../branches/gcc-7-branch)
@@ -0,0 +1,18 @@
+! { dg-do compile }
+! PR 80118 - this used to ICE
+! Original test case by Marco Restelli
+module m
+implicit none
+
+  integer, parameter :: not_empty(1) = 0
+  integer, parameter :: empty1(0) = (/integer :: /)
+  integer, parameter :: empty2(0) = 0
+
+contains
+
+ subroutine sub(v)
+  integer, allocatable, intent(out) :: v(:)
+   v = 2*empty2 ! internal compiler error
+ end subroutine sub
+
+end module m
Index: gcc/testsuite/gfortran.dg/pr81723.f
===================================================================
--- gcc/testsuite/gfortran.dg/pr81723.f	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gfortran.dg/pr81723.f	(.../branches/gcc-7-branch)
@@ -0,0 +1,56 @@
+! { dg-do compile }
+! { dg-options "-O3 -fno-automatic" }
+
+      FUNCTION WWERF(Z)
+
+      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
+      COMPLEX*16 WWERF
+      COMPLEX*16 Z,ZH,R(37),S,T,V,W
+
+      PARAMETER (Z1 = 1, HF = Z1/2, Z10 = 10)
+      PARAMETER (C1 = 74/Z10, C2 = 83/Z10, C3 = Z10/32, C4 = 16/Z10)
+      PARAMETER (C = 1.12837 91670 95512 57D0, P = (2*C4)**33)
+
+      DOUBLE PRECISION GREAL,GIMAG,XARG,YARG
+      COMPLEX*16 ZARG,GCONJG,GCMPLX
+      GREAL( ZARG)=DREAL( ZARG)
+      GIMAG( ZARG)=DIMAG( ZARG)
+      GCONJG(ZARG)=DCONJG(ZARG)
+      GCMPLX(XARG,YARG)=DCMPLX(XARG,YARG)
+
+      X=Z
+      Y=GIMAG(Z)
+      XA=ABS(X)
+      YA=ABS(Y)
+      IF(YA .LT. C1 .AND. XA .LT. C2) THEN
+       ZH=GCMPLX(YA+C4,XA)
+       R(37)=0
+       DO 1 N = 36,1,-1
+       T=ZH+N*GCONJG(R(N+1))
+    1  R(N)=HF*T/(GREAL(T)**2+GIMAG(T)**2)
+       XL=P
+       S=0
+       DO 2 N = 33,1,-1
+       XL=C3*XL
+    2  S=R(N)*(S+XL)
+       V=C*S
+      ELSE
+       ZH=GCMPLX(YA,XA)
+       R(1)=0
+       DO 3 N = 9,1,-1
+       T=ZH+N*GCONJG(R(1))
+    3  R(1)=HF*T/(GREAL(T)**2+GIMAG(T)**2)
+       V=C*R(1)
+      END IF
+      IF(YA .EQ. 0) V=GCMPLX(EXP(-XA**2),GIMAG(V))
+      IF(Y .LT. 0) THEN
+       V=2*EXP(-GCMPLX(XA,YA)**2)-V
+       IF(X .GT. 0) V=GCONJG(V)
+      ELSE
+       IF(X .LT. 0) V=GCONJG(V)
+      END IF
+
+      WWERF=V
+
+      RETURN
+      END
Index: gcc/testsuite/gfortran.dg/warn_target_lifetime_4.f90
===================================================================
--- gcc/testsuite/gfortran.dg/warn_target_lifetime_4.f90	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gfortran.dg/warn_target_lifetime_4.f90	(.../branches/gcc-7-branch)
@@ -0,0 +1,28 @@
+! { dg-do compile }
+! { dg-options "-Wtarget-lifetime" }
+!
+! PR fortran/81770: [5/6/7 Regression] Bogus warning: Pointer in pointer assignment might outlive the pointer target
+!
+! Contributed by Janus Weil <janus@gcc.gnu.org>
+
+module m
+
+   type t
+      integer, allocatable :: l
+   end type
+
+contains
+
+   subroutine sub(c_in, list)
+      type(t), target, intent(in)  :: c_in
+      integer, pointer, intent(out) :: list
+
+      type(t), pointer :: container
+
+      container => c_in
+
+      list => container%l
+
+   end subroutine
+
+end
Index: gcc/testsuite/gcc.c-torture/execute/pr81503.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr81503.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.c-torture/execute/pr81503.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,15 @@
+unsigned short a = 41461;
+unsigned short b = 3419;
+int c = 0;
+
+void foo() {
+  if (a + b * ~(0 != 5))
+    c = -~(b * ~(0 != 5)) + 2147483647;
+}
+
+int main() {
+  foo();
+  if (c != 2147476810)
+    return -1;
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr82524.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr82524.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.c-torture/execute/pr82524.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,37 @@
+/* PR target/82524 */
+
+struct S { unsigned char b, g, r, a; };
+union U { struct S c; unsigned v; };
+
+static inline unsigned char
+foo (unsigned char a, unsigned char b)
+{
+  return ((a + 1) * b) >> 8;
+}
+
+__attribute__((noinline, noclone)) unsigned
+bar (union U *x, union U *y)
+{
+  union U z;
+  unsigned char v = x->c.a;
+  unsigned char w = foo (y->c.a, 255 - v);
+  z.c.r = foo (x->c.r, v) + foo (y->c.r, w);
+  z.c.g = foo (x->c.g, v) + foo (y->c.g, w);
+  z.c.b = foo (x->c.b, v) + foo (y->c.b, w);
+  z.c.a = 0;
+  return z.v;
+}
+
+int
+main ()
+{
+  union U a, b, c;
+  if ((unsigned char) ~0 != 255 || sizeof (unsigned) != 4)
+    return 0;
+  a.c = (struct S) { 255, 255, 255, 0 };
+  b.c = (struct S) { 255, 255, 255, 255 };
+  c.v = bar (&a, &b);
+  if (c.c.b != 255 || c.c.g != 255 || c.c.r != 255 || c.c.a != 0)
+    __builtin_abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/compile/string-large-1.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/string-large-1.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.c-torture/compile/string-large-1.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,119 @@
+/* Test built-in string functions with large sizes.  PR 78460.  */
+
+typedef __SIZE_TYPE__ size_t;
+
+#define SIZE1 ((size_t) -1)
+#define SIZE2 (SIZE1 >> 1)
+#define SIZE3 ((unsigned int) -1)
+#define SIZE4 (SIZE3 >> 1)
+
+volatile int v1, v2, v3, v4;
+void *volatile vp1, *volatile vp2, *volatile vp3, *volatile vp4;
+
+void
+test_memchr (const void *a, int b)
+{
+  vp1 = __builtin_memchr (a, b, SIZE1);
+  vp2 = __builtin_memchr (a, b, SIZE2);
+  vp3 = __builtin_memchr (a, b, SIZE3);
+  vp4 = __builtin_memchr (a, b, SIZE4);
+}
+
+void
+test_memcmp (const void *a, const void *b)
+{
+  v1 = __builtin_memcmp (a, b, SIZE1);
+  v2 = __builtin_memcmp (a, b, SIZE2);
+  v3 = __builtin_memcmp (a, b, SIZE3);
+  v4 = __builtin_memcmp (a, b, SIZE4);
+}
+
+void
+test_memcpy (void *a, const void *b)
+{
+  vp1 = __builtin_memcpy (a, b, SIZE1);
+  vp2 = __builtin_memcpy (a, b, SIZE2);
+  vp3 = __builtin_memcpy (a, b, SIZE3);
+  vp4 = __builtin_memcpy (a, b, SIZE4);
+}
+
+void
+test_memmove (void *a, const void *b)
+{
+  vp1 = __builtin_memmove (a, b, SIZE1);
+  vp2 = __builtin_memmove (a, b, SIZE2);
+  vp3 = __builtin_memmove (a, b, SIZE3);
+  vp4 = __builtin_memmove (a, b, SIZE4);
+}
+
+void
+test_mempcpy (void *a, const void *b)
+{
+  vp1 = __builtin_mempcpy (a, b, SIZE1);
+  vp2 = __builtin_mempcpy (a, b, SIZE2);
+  vp3 = __builtin_mempcpy (a, b, SIZE3);
+  vp4 = __builtin_mempcpy (a, b, SIZE4);
+}
+
+void
+test_memset (void *a, int b)
+{
+  vp1 = __builtin_memset (a, b, SIZE1);
+  vp2 = __builtin_memset (a, b, SIZE2);
+  vp3 = __builtin_memset (a, b, SIZE3);
+  vp4 = __builtin_memset (a, b, SIZE4);
+}
+
+void
+test_stpncpy (char *a, const char *b)
+{
+  vp1 = __builtin_stpncpy (a, b, SIZE1);
+  vp2 = __builtin_stpncpy (a, b, SIZE2);
+  vp3 = __builtin_stpncpy (a, b, SIZE3);
+  vp4 = __builtin_stpncpy (a, b, SIZE4);
+}
+
+void
+test_strndup (const char *a)
+{
+  vp1 = __builtin_strndup (a, SIZE1);
+  vp2 = __builtin_strndup (a, SIZE2);
+  vp3 = __builtin_strndup (a, SIZE3);
+  vp4 = __builtin_strndup (a, SIZE4);
+}
+
+void
+test_strncasecmp (const char *a, const char *b)
+{
+  v1 = __builtin_strncasecmp (a, b, SIZE1);
+  v2 = __builtin_strncasecmp (a, b, SIZE2);
+  v3 = __builtin_strncasecmp (a, b, SIZE3);
+  v4 = __builtin_strncasecmp (a, b, SIZE4);
+}
+
+void
+test_strncat (char *a, const char *b)
+{
+  vp1 = __builtin_strncat (a, b, SIZE1);
+  vp2 = __builtin_strncat (a, b, SIZE2);
+  vp3 = __builtin_strncat (a, b, SIZE3);
+  vp4 = __builtin_strncat (a, b, SIZE4);
+}
+
+void
+test_strncmp (const char *a, const char *b)
+{
+  v1 = __builtin_strncmp (a, b, SIZE1);
+  v2 = __builtin_strncmp (a, b, SIZE2);
+  v3 = __builtin_strncmp (a, b, SIZE3);
+  v4 = __builtin_strncmp (a, b, SIZE4);
+}
+
+void
+test_strncpy (char *a, const char *b)
+{
+  vp1 = __builtin_strncpy (a, b, SIZE1);
+  vp2 = __builtin_strncpy (a, b, SIZE2);
+  vp3 = __builtin_strncpy (a, b, SIZE3);
+  vp4 = __builtin_strncpy (a, b, SIZE4);
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr82337.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr82337.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.c-torture/compile/pr82337.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,25 @@
+/* PR82337: SLSR needs to prevent abnormal SSA names from
+   serving as a basis. */
+char *a, *b, *c;
+
+struct d {
+  short e;
+  char f[];
+};
+
+extern void j (void);
+
+void
+g() {
+  struct d *h;
+  char *i;
+  int d;
+  do {
+    i = h->f + d;
+    20 ? j() : 0;
+    i = c;
+    if (__builtin_setjmp (h))
+      b = h->f + d;
+    d = (int)(*i);
+  } while (a);
+}
Index: gcc/testsuite/gnat.dg/incomplete5_pkg.adb
===================================================================
--- gcc/testsuite/gnat.dg/incomplete5_pkg.adb	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/incomplete5_pkg.adb	(.../branches/gcc-7-branch)
@@ -0,0 +1,13 @@
+package body Incomplete5_Pkg is
+
+   function Get_Handle (Object: Base_Object) return Access_Type is
+   begin
+      return Object.Handle;
+   end;
+
+   function From_Handle (Handle: Access_Type) return Base_Object is
+   begin
+      return (Handle=>Handle);
+   end;
+
+end Incomplete5_Pkg;
Index: gcc/testsuite/gnat.dg/incomplete5_pkg.ads
===================================================================
--- gcc/testsuite/gnat.dg/incomplete5_pkg.ads	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/incomplete5_pkg.ads	(.../branches/gcc-7-branch)
@@ -0,0 +1,15 @@
+generic
+   type Record_Type;
+package Incomplete5_Pkg is
+
+   type Access_Type is access Record_Type;
+
+   type Base_Object is tagged record
+      Handle: Access_Type;
+   end record;
+
+   function Get_Handle(Object: Base_Object) return Access_Type;
+
+   function From_Handle(Handle: Access_Type) return Base_Object;
+
+end Incomplete5_Pkg;
Index: gcc/testsuite/gnat.dg/array29.adb
===================================================================
--- gcc/testsuite/gnat.dg/array29.adb	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/array29.adb	(.../branches/gcc-7-branch)
@@ -0,0 +1,26 @@
+-- { dg-do compile }
+-- { dg-options "-O" }
+
+package body Array29 is
+
+  procedure Copy (Src : in Matrix; Dst : out Matrix) is
+  begin
+    for I in Src'Range (1) loop
+      for J in Src'Range (2) loop
+        Dst (I, J) := Src (I, J);
+      end loop;
+    end loop;
+  end;
+
+  procedure Proc is
+    N : constant := 2;
+    FM1 : constant Matrix (1 .. N, 1 .. N) := ((1.0, 2.0), (3.0, 4.0));
+    FM2 : constant Matrix (1 .. N, 1 .. N) := ((1.0, 2.0), (3.0, 4.0));
+    A : constant array (1 .. 2) of Matrix (1 .. N, 1 .. N)
+      := (Matrix (FM1), Matrix (FM2));
+    Final : Matrix (1 .. N, 1 .. N);
+  begin
+    Copy (Src => A (1), Dst => Final);
+  end;
+
+end Array29;
Index: gcc/testsuite/gnat.dg/array29.ads
===================================================================
--- gcc/testsuite/gnat.dg/array29.ads	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/array29.ads	(.../branches/gcc-7-branch)
@@ -0,0 +1,7 @@
+package Array29 is
+
+  type Matrix is array (Integer range <>, Integer range <>) of Long_Float;
+
+  procedure Proc;
+
+end Array29;
Index: gcc/testsuite/gnat.dg/debug13.adb
===================================================================
--- gcc/testsuite/gnat.dg/debug13.adb	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/debug13.adb	(.../branches/gcc-7-branch)
@@ -0,0 +1,38 @@
+--  { dg-options "-cargs -O2 -g -margs" }
+
+package body Debug13 is
+
+   procedure Compile (P : Natural)
+   is
+      Max_Pos : constant Natural := P;
+      type Position_Set is array (1 .. Max_Pos) of Boolean;
+
+      Empty  : constant Position_Set := (others => False);
+
+      type Position_Set_Array is array (1 .. Max_Pos) of Position_Set;
+
+      Follow  : Position_Set_Array := (others => Empty);
+
+      function Get_Follows return Position_Set;
+
+      procedure Make_DFA;
+
+      function Get_Follows return Position_Set is
+         Result : Position_Set := Empty;
+      begin
+         Result := Result or Follow (1);
+
+         return Result;
+      end Get_Follows;
+
+      procedure Make_DFA is
+         Next   : constant Position_Set := Get_Follows;
+      begin
+         null;
+      end Make_DFA;
+
+   begin
+      Make_DFA;
+   end Compile;
+
+end Debug13;
Index: gcc/testsuite/gnat.dg/debug13.ads
===================================================================
--- gcc/testsuite/gnat.dg/debug13.ads	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/debug13.ads	(.../branches/gcc-7-branch)
@@ -0,0 +1,5 @@
+package Debug13 is
+
+   procedure Compile (P : Natural);
+
+end Debug13;
Index: gcc/testsuite/gnat.dg/incomplete5.adb
===================================================================
--- gcc/testsuite/gnat.dg/incomplete5.adb	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/incomplete5.adb	(.../branches/gcc-7-branch)
@@ -0,0 +1,10 @@
+-- { dg-do compile }
+
+package body Incomplete5 is
+
+   function Get (O: Base_Object) return Integer is
+   begin
+      return Get_Handle(O).I;
+   end;
+
+end Incomplete5;
Index: gcc/testsuite/gnat.dg/incomplete5.ads
===================================================================
--- gcc/testsuite/gnat.dg/incomplete5.ads	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/incomplete5.ads	(.../branches/gcc-7-branch)
@@ -0,0 +1,25 @@
+with Incomplete5_Pkg;
+
+package Incomplete5 is
+
+   type Rec1 is private;
+
+   type Rec2 is private;
+
+   package My_G is new Incomplete5_Pkg (Rec1);
+
+   use My_G;
+
+   function Get (O: Base_Object) return Integer;
+
+private
+
+   type Rec1 is record
+      I : Integer;
+   end record;
+
+   type Rec2 is record
+      A : Access_Type;
+   end record;
+
+end Incomplete5;
Index: gcc/testsuite/gnat.dg/pack9.adb
===================================================================
--- gcc/testsuite/gnat.dg/pack9.adb	(.../tags/gcc_7_2_0_release)
+++ gcc/testsuite/gnat.dg/pack9.adb	(.../branches/gcc-7-branch)
@@ -1,7 +1,8 @@
 -- { dg-do compile }
 -- { dg-options "-O2 -gnatp -fdump-tree-optimized" }
--- See PR tree-optimization/46801 for the expected failure
 
+pragma Optimize_Alignment (Space);
+
 package body Pack9 is
 
   procedure Copy (X, Y : R2_Ptr) is
Index: gcc/testsuite/gnat.dg/specs/uc2.ads
===================================================================
--- gcc/testsuite/gnat.dg/specs/uc2.ads	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/specs/uc2.ads	(.../branches/gcc-7-branch)
@@ -0,0 +1,18 @@
+-- { dg-do compile }
+-- { dg-options "-O" }
+
+with Ada.Unchecked_Conversion;
+
+package UC2 is
+
+  subtype Word_Type is Integer range 0 .. 0;
+  type Arr is array (1 .. Word_Type'Size) of Boolean;
+  pragma Pack(Arr);
+
+  function Conv is
+     new Ada.Unchecked_Conversion (Source => Arr, Target => Word_Type);
+
+  A : Arr;
+  W : Word_Type := Conv(A);
+
+end UC2;
Index: gcc/testsuite/gnat.dg/specs/vfa2.ads
===================================================================
--- gcc/testsuite/gnat.dg/specs/vfa2.ads	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/specs/vfa2.ads	(.../branches/gcc-7-branch)
@@ -0,0 +1,110 @@
+-- { dg-do compile }
+-- { dg-options "-O" }
+
+package VFA2 is
+
+   type Bit is mod 2**1
+     with Size => 1;
+   type UInt2 is mod 2**2
+     with Size => 2;
+   type UInt22 is mod 2**22
+     with Size => 22;
+
+   type MODE_ENUM is
+     (
+      Function_0_Default,
+      Function_1,
+      Function_2,
+      Function_3,
+      Function_4,
+      Function_5,
+      Function_6,
+      Function_7)
+     with Size => 3;
+
+   type EPD_ENUM is
+     (
+      Disable_Pull_Down,
+      Enable_Pull_Down)
+     with Size => 1;
+
+   type EPUN_ENUM is
+     (
+      Enable_Pull_Up,
+      Disable_Pull_Up)
+     with Size => 1;
+
+   type EHS_ENUM is
+     (
+      Slow_Low_Noise_With,
+      Fast_Medium_Noise_W)
+     with Size => 1;
+
+   type EZI_ENUM is
+     (
+      Disable_Input_Buffer,
+      Enable_Input_Buffer)
+     with Size => 1;
+
+   type ZIF_ENUM is
+     (
+      Enable_Input_Glitch,
+      Disable_Input_Glitch)
+     with Size => 1;
+
+   type EHD_ENUM is
+     (
+      Normal_Drive_4_Ma_D,
+      Medium_Drive_8_Ma_D,
+      High_Drive_14_Ma_Dr,
+      Ultra_High_Drive_20)
+     with Size => 2;
+
+   type Pin_Type is (Normal_Drive, High_Drive, High_Speed);
+
+   type SFS_Register(Pin : Pin_Type := Normal_Drive) is record
+      MODE     : MODE_ENUM;
+      EPD      : EPD_ENUM;
+      EPUN     : EPUN_ENUM;
+      EZI      : EZI_ENUM;
+      ZIF      : ZIF_ENUM;
+      RESERVED : UInt22;
+
+      case Pin is
+         when Normal_Drive =>
+
+            ND_EHS_RESERVED : Bit;
+            ND_EHD_RESERVED : UInt2;
+
+         when High_Drive =>
+
+            EHD : EHD_ENUM;
+            HD_EHS_RESERVED : Bit;
+
+         when High_Speed =>
+            EHS    : EHS_ENUM;
+            HS_EHD_RESERVED : UInt2;
+
+      end case;
+   end record
+     with Unchecked_Union, Size => 32, Volatile_Full_Access;
+
+   for SFS_Register use record
+      MODE            at 0 range 0 .. 2;
+      EPD             at 0 range 3 .. 3;
+      EPUN            at 0 range 4 .. 4;
+      ND_EHS_RESERVED at 0 range 5 .. 5;
+      HD_EHS_RESERVED at 0 range 5 .. 5;
+      EHS             at 0 range 5 .. 5;
+      EZI             at 0 range 6 .. 6;
+      ZIF             at 0 range 7 .. 7;
+      ND_EHD_RESERVED at 0 range 8 .. 9;
+      EHD             at 0 range 8 .. 9;
+      HS_EHD_RESERVED at 0 range 8 .. 9;
+      RESERVED        at 0 range 10 .. 31;
+   end record;
+
+   type Normal_Drive_Pins is array (Integer range <>)
+     of SFS_Register(Normal_Drive) with Volatile;
+
+end VFA2;
Index: gcc/testsuite/gnat.dg/specs/atomic3.ads
===================================================================
--- gcc/testsuite/gnat.dg/specs/atomic3.ads	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/specs/atomic3.ads	(.../branches/gcc-7-branch)
@@ -0,0 +1,33 @@
+-- { dg-do compile }
+
+package Atomic3 is
+
+   type Four_Bits is mod 2**4;
+   type Fourteen_Bits is mod 2**14;
+   type Twenty_Eight_Bits is mod 2**28;
+
+   type Rec1 (Mode : Boolean := True) is record
+      Reserved : Four_Bits;
+      case Mode is
+         when True =>
+           High_Part : Fourteen_Bits;
+           Low_Part  : Fourteen_Bits;
+         when False =>
+           Data : Twenty_Eight_Bits;
+      end case;
+   end record;
+   for Rec1 use record
+      Reserved  at 0 range 28 .. 31;
+      High_Part at 0 range 14 .. 27;
+      Low_Part  at 0 range  0 .. 13;
+      Data      at 0 range  0 .. 27;
+   end record;
+   for Rec1'Size use 32;
+   pragma Unchecked_Union (Rec1);
+
+   type Rec2 is record
+      A : Rec1;
+      pragma Atomic (A);
+   end record;
+
+end Atomic3;
Index: gcc/testsuite/gnat.dg/specs/vfa1.ads
===================================================================
--- gcc/testsuite/gnat.dg/specs/vfa1.ads	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/specs/vfa1.ads	(.../branches/gcc-7-branch)
@@ -0,0 +1,14 @@
+-- { dg-do compile }
+-- { dg-options "-g" }
+
+package VFA1 is
+
+  type Rec is record
+    A : Short_Integer;
+    B : Short_Integer;
+  end record;
+
+  type Rec_VFA is new Rec;
+  pragma Volatile_Full_Access (Rec_VFA);
+
+end VFA1;
Index: gcc/testsuite/gcc.dg/pr82112.c
===================================================================
--- gcc/testsuite/gcc.dg/pr82112.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/pr82112.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,21 @@
+/* PR target/82112 */
+/* { dg-do compile } */
+/* { dg-options "-std=gnu90" } */
+
+struct S { int a[10]; } bar (void);
+int b, c;
+
+void
+foo (void)
+{
+  __atomic_load (bar ().a, &b, __ATOMIC_ACQUIRE);	/* { dg-error "argument 1 of .__atomic_load. must be a non-void pointer type" } */
+  __atomic_load (&b, bar ().a, __ATOMIC_ACQUIRE);	/* { dg-error "argument 2 of .__atomic_load. must be a pointer type" } */
+  __atomic_store (bar ().a, &b, __ATOMIC_SEQ_CST);	/* { dg-error "argument 1 of .__atomic_store. must be a non-void pointer type" } */
+  __atomic_store (&b, bar ().a, __ATOMIC_SEQ_CST);	/* { dg-error "argument 2 of .__atomic_store. must be a pointer type" } */
+  __atomic_exchange (bar ().a, &b, &c, __ATOMIC_RELAXED);	/* { dg-error "argument 1 of .__atomic_exchange. must be a non-void pointer type" } */
+  __atomic_exchange (&b, bar ().a, &c, __ATOMIC_RELAXED);	/* { dg-error "argument 2 of .__atomic_exchange. must be a pointer type" } */
+  __atomic_exchange (&b, &c, bar ().a, __ATOMIC_RELAXED);	/* { dg-error "argument 3 of .__atomic_exchange. must be a pointer type" } */
+  __atomic_compare_exchange (bar ().a, &b, &c, 1, __ATOMIC_RELAXED, __ATOMIC_RELAXED);	/* { dg-error "argument 1 of .__atomic_compare_exchange. must be a non-void pointer type" } */
+  __atomic_compare_exchange (&b, bar ().a, &c, 1, __ATOMIC_RELAXED, __ATOMIC_RELAXED);	/* { dg-error "argument 2 of .__atomic_compare_exchange. must be a pointer type" } */
+  __atomic_compare_exchange (&b, &c, bar ().a, 1, __ATOMIC_RELAXED, __ATOMIC_RELAXED);	/* { dg-error "argument 3 of .__atomic_compare_exchange. must be a pointer type" } */
+}
Index: gcc/testsuite/gcc.dg/gimplefe-14.c
===================================================================
--- gcc/testsuite/gcc.dg/gimplefe-14.c	(.../tags/gcc_7_2_0_release)
+++ gcc/testsuite/gcc.dg/gimplefe-14.c	(.../branches/gcc-7-branch)
@@ -7,7 +7,9 @@
   int a;
 
   bb_2:
-  switch (argc_2(D)) {default: L2; case 1: L0; case 2: L1; }
+  /* Because of PR82114 we need to handle also 0 as base metal can have
+     argc == 0.  */
+  switch (argc_2(D)) {default: L2; case 0: L0; case 1: L0; case 2: L1; }
 
 L0:
   a_4 = 0;
Index: gcc/testsuite/gcc.dg/gomp/pr81768-2.c
===================================================================
--- gcc/testsuite/gcc.dg/gomp/pr81768-2.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/gomp/pr81768-2.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,15 @@
+/* PR middle-end/81768 */
+/* { dg-do compile } */
+
+float b[10][15][10];
+
+void
+foo (void)
+{
+  float *i;
+#pragma omp target parallel for schedule(static, 32) collapse(3)
+  for (i = &b[0][0][0]; i < &b[0][0][10]; i++)
+    for (float *j = &b[0][15][0]; j > &b[0][0][0]; j -= 10)
+      for (float *k = &b[0][0][10]; k > &b[0][0][0]; --k)
+        b[i - &b[0][0][0]][(j - &b[0][0][0]) / 10 - 1][(k - &b[0][0][0]) - 1] -= 3.5;
+}
Index: gcc/testsuite/gcc.dg/gomp/pr81768-1.c
===================================================================
--- gcc/testsuite/gcc.dg/gomp/pr81768-1.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/gomp/pr81768-1.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,15 @@
+/* PR middle-end/81768 */
+/* { dg-do compile } */
+
+float b[10][15][10];
+
+void
+foo (void)
+{
+  float *i;
+#pragma omp target parallel for simd schedule(static, 32) collapse(3)
+  for (i = &b[0][0][0]; i < &b[0][0][10]; i++)
+    for (float *j = &b[0][15][0]; j > &b[0][0][0]; j -= 10)
+      for (float *k = &b[0][0][10]; k > &b[0][0][0]; --k)
+	b[i - &b[0][0][0]][(j - &b[0][0][0]) / 10 - 1][(k - &b[0][0][0]) - 1] -= 3.5;
+}
Index: gcc/testsuite/gcc.dg/asan/pr81923.c
===================================================================
--- gcc/testsuite/gcc.dg/asan/pr81923.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/asan/pr81923.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,10 @@
+/* PR sanitizer/81923 */
+/* { dg-do link } */
+
+int foobar __asm (__USER_LABEL_PREFIX__ "barbaz") = 34;
+
+int
+main ()
+{
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/pr81621.c
===================================================================
--- gcc/testsuite/gcc.dg/pr81621.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/pr81621.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,5 @@
+/* PR target/81621 */
+/* { dg-do compile { target freorder } } */
+/* { dg-options "-Og -fno-split-wide-types -freorder-blocks-and-partition" } */
+
+#include "graphite/scop-10.c"
Index: gcc/testsuite/gcc.dg/torture/pr82276.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr82276.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/torture/pr82276.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,32 @@
+/* { dg-do compile } */
+
+typedef struct a {
+  struct a *b;
+} a;
+
+extern int d(void);
+extern int g(void);
+extern int h(void);
+extern int _setjmp();
+extern int i(void);
+
+void c(void) {
+    1 ? d() : 0;
+    a *e;
+    while (e) {
+	e = (e == (a *) c) ? 0 : e->b;
+	while (e) {
+	    unsigned int f = 0;
+	    g();
+	    _setjmp(f);
+	    if (f & 6) {
+		;
+	    } else if (f & 2) {
+		;
+	    } else {
+		h();
+	    }
+	    i();
+	}
+    }
+}
Index: gcc/testsuite/gcc.dg/torture/pr82285.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr82285.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/torture/pr82285.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,16 @@
+/* { dg-do run } */
+
+enum tst { first = 0, second = 1 };
+
+int
+main ()
+{
+  enum tst data[16];
+
+  for (unsigned i = 0; i < 16; i++)
+    data[i] = (i < 5 ? second : first);
+
+  if (data[2] != second)
+    __builtin_abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/torture/pr81181.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr81181.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/torture/pr81181.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,30 @@
+/* { dg-do compile } */
+
+unsigned int lh;
+
+void
+ny (int t3, int ys, int rt, int p8)
+{
+  if (lh != 0)
+    {
+      if (0)
+	{
+oo:
+	  do
+	    {
+	      rt = (p8 != 0) ? t3 : 0;
+	      rt = (rt != 0 || lh != (unsigned int)ys);
+	      rt += lh + ys;
+	    }
+	  while (t3 <= 0);
+
+	  lh = ys;
+	  ys = rt;
+	}
+
+      if (lh != 0)
+	p8 = lh;
+    }
+
+  goto oo;
+}
Index: gcc/testsuite/gcc.dg/torture/pr82244.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr82244.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/torture/pr82244.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,31 @@
+/* { dg-do compile } */
+
+typedef struct a {
+  struct a *b;
+} a;
+
+extern int d(void);
+extern int g(void);
+extern int h(void);
+extern int _setjmp(void *);
+
+int c(void)
+{
+  1 ? d() : 0;
+
+  a *e;
+  while (e) {
+      e = (e == (a *) c) ? 0 : e->b;
+      while (e) {
+	  int f = 0;
+	  g();
+	  if (_setjmp(0)) {
+	      if (f & 6) {
+		  ;
+	      } else if (f & 2) {
+		  h();
+	      }
+	  }
+      }
+  }
+}
Index: gcc/testsuite/gcc.dg/torture/pr82264.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr82264.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/torture/pr82264.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,21 @@
+/* { dg-do compile } */
+
+char a;
+int c;
+unsigned b ();
+unsigned
+setjmp ()
+{
+}
+static void
+d ()
+{
+  if (b ())
+    c = 3;
+}
+void
+e ()
+{
+  d ();
+  a && ({ setjmp (); });
+}
Index: gcc/testsuite/gcc.dg/torture/pr82291.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr82291.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/torture/pr82291.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,37 @@
+/* { dg-do run } */
+
+int a, c, d, *h;
+unsigned b;
+
+int *fn1 ()
+{ 
+  int *f[3], g = 0;
+  for (; g < 3; g++)
+    f[g] = &a;
+  if (--b > a)
+    { 
+      if (a > b)
+	d++;
+      return f[0];
+    }
+}
+
+void fn2 ()
+{ 
+  for (; c >= 0; --c)
+    { 
+      int j[] = { 0, 0, 0, 0, 0 };
+      int *k = fn1 ();
+      if (!k)
+	__builtin_abort ();
+      h = &j[4];
+    }
+}
+
+int main ()
+{ 
+  fn2 ();
+  if (d != 0)
+    __builtin_abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/pr81650.c
===================================================================
--- gcc/testsuite/gcc.dg/pr81650.c	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/pr81650.c	(.../branches/gcc-7-branch)
@@ -0,0 +1,9 @@
+/* PR driver/81650 */
+/* { dg-do compile } */
+/* { dg-options "-Walloc-size-larger-than=9223372036854775807" } */
+
+void *
+foo (void)
+{
+  return __builtin_malloc (5);
+}
Index: gcc/testsuite/gcc.dg/tree-ssa/pr81588.c
===================================================================
--- gcc/testsuite/gcc.dg/tree-ssa/pr81588.c	(.../tags/gcc_7_2_0_release)
+++ gcc/testsuite/gcc.dg/tree-ssa/pr81588.c	(.../branches/gcc-7-branch)
@@ -1,5 +1,5 @@
 /* PR tree-optimization/81588 */
-/* { dg-do compile { target { ! "m68k*-*-* mmix*-*-* bfin*-*-* v850*-*-* moxie*-*-* cris*-*-* m32c*-*-* fr30*-*-* mcore*-*-* powerpc*-*-* xtensa*-*-* hppa*-*-* nios2*-*-*" } } } */
+/* { dg-do compile { target { ! { { logical_op_short_circuit && { ! "mips*-*-* avr-*-* s390*-*-*" } } || { m68k*-*-* bfin*-*-* v850*-*-* moxie*-*-* m32c*-*-* fr30*-*-* mcore*-*-* xtensa*-*-* hppa*-*-* } } } } } */
 /* { dg-options "-O2 -fdump-tree-reassoc1-details" } */
 /* { dg-additional-options "-mbranch-cost=2" { target mips*-*-* avr-*-* s390*-*-* i?86-*-* x86_64-*-* } } */
 
